const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const items = sequelize.define(
    'items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

item_name: {
        type: DataTypes.TEXT,
      
      

      },

item_code: {
        type: DataTypes.TEXT,
      
      

      },

item_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"raw_material",


"component",


"subassembly",


"finished_good",


"consumable",


"packaging"

        ],

      },

lot_tracked: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

serial_tracked: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

standard_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

shelf_life_days: {
        type: DataTypes.INTEGER,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity











    db.items.hasMany(db.approved_vendors, {
      as: 'approved_vendors_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });


    db.items.hasMany(db.boms, {
      as: 'boms_parent_item',
      foreignKey: {
          name: 'parent_itemId',
      },
      constraints: false,
    });


    db.items.hasMany(db.bom_lines, {
      as: 'bom_lines_component_item',
      foreignKey: {
          name: 'component_itemId',
      },
      constraints: false,
    });


    db.items.hasMany(db.routings, {
      as: 'routings_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });







    db.items.hasMany(db.work_orders, {
      as: 'work_orders_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });



    db.items.hasMany(db.lots, {
      as: 'lots_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });


    db.items.hasMany(db.serials, {
      as: 'serials_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });


    db.items.hasMany(db.inventory_balances, {
      as: 'inventory_balances_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });


    db.items.hasMany(db.inventory_movements, {
      as: 'inventory_movements_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });



    db.items.hasMany(db.purchase_order_lines, {
      as: 'purchase_order_lines_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });


    db.items.hasMany(db.inspection_plans, {
      as: 'inspection_plans_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });



    db.items.hasMany(db.inspections, {
      as: 'inspections_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });



    db.items.hasMany(db.nonconformances, {
      as: 'nonconformances_item',
      foreignKey: {
          name: 'itemId',
      },
      constraints: false,
    });






//end loop



    db.items.belongsTo(db.uoms, {
      as: 'default_uom',
      foreignKey: {
        name: 'default_uomId',
      },
      constraints: false,
    });




    db.items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return items;
};


